﻿using System;
using KellermanSoftware.Common;
using KellermanSoftware.NetPasswordGenerator;

namespace KellermanSoftware.NetPasswordGeneratorDemo
{
    public class Register: ILicenseInterface
    {
        private const string _product = "NetPasswordGenerator";
        private const string _company = "KellermanSoftware";
        private SettingsConfig _config;

        public Register()
        {
            _config = new SettingsConfig();
            _config.CompanyName = _company;
            _config.ProjectName = _product;
            _config.EncryptionPassword = "#2Wa#m@LJa29XdPP";
            LoadRegistration();
        }

        private void LoadRegistration()
        {
            SettingsLogic settingsLogic = new SettingsLogic(_config);
            UserName = settingsLogic.GetSetting("Registration", "UserName") ?? string.Empty;
            License = settingsLogic.GetSetting("Registration", "License") ?? string.Empty;
            LicensedUser = !String.IsNullOrEmpty(UserName) && !String.IsNullOrEmpty(License);
        }

        private void SaveRegistration()
        {
            SettingsLogic settingsLogic = new SettingsLogic(_config);
            settingsLogic.SaveSetting("Registration", "UserName", UserName);
            settingsLogic.SaveSetting("Registration", "License", License);
        }

        public bool ExtendTrial(string trialExtension)
        {
            throw new NotImplementedException();
        }

        public string TrialMessage()
        {
            throw new NotImplementedException();
        }

        public int TrialDaysLeft()
        {
            throw new NotImplementedException();
        }

        public bool CheckLicense()
        {
            try
            {
                PasswordGenerator generator = new PasswordGenerator(UserName, License);
                LicensedUser = !String.IsNullOrEmpty(UserName) && !String.IsNullOrEmpty(License);

                if (LicensedUser)
                {
                    SaveRegistration();
                }
                return true;
            }
            catch (Exception ex)
            {
                AdditionalInfo = ex.Message;
                return false;
            }
        }

        public bool TrialValid()
        {
            throw new NotImplementedException();
        }

        public string AdditionalInfo { get; set; }
        public string UserName { get; set; }
        public string License { get; set; }
        public bool LicensedUser { get; set; }
    }
}
